//
//  MainViewController.m
//  FoodAddict
//
//  Created by Ngo Anh Hoang on 4/8/13.
//  Copyright (c) 2013 HoangNA. All rights reserved.
//
#define NUMBER_DISHES 6
#import "MainViewController.h"
#import "DetailsViewController.h"
#import "DataManager.h"
@interface MainViewController ()
{
    DetailsViewController *_detailsView;
    NSDictionary *_plistData;
    NSArray *_plistRowData;
    NSString *_tempName, *_tempImg, *_tempDesc;
}
@end

@implementation MainViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        self.title = @"Food Menu";
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    for (int i = 1; i <= NUMBER_DISHES; i++) {
        UIView *view = [self.view viewWithTag:i];
        if([view isMemberOfClass:[UIButton class]]) {
            UIButton *button = (UIButton *) view; // casting
            [button addTarget:self action:@selector(onUserTap:) forControlEvents:UIControlEventTouchUpInside];
        }
    }
    // load data
    [self loadData];
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
#pragma mark -- Handle user interaction
// handle action when user tap on any icons(buttons)
- (void)onUserTap:(UIButton *) button{
    //if(!_detailsView) {
        _detailsView = [[DetailsViewController alloc] initWithNibName:@"DetailsViewController" bundle:nil];
    //}
    // Fill data by index of buttons
    _plistRowData = (NSArray *) [_plistData objectForKey:[NSString stringWithFormat:@"%d", button.tag]];
    //NSLog(@"%@", _plistRowData);
    _tempName = (NSString *) [_plistRowData objectAtIndex:0];
    _tempImg = (NSString *) [_plistRowData objectAtIndex:1];
    _tempDesc = (NSString *) [_plistRowData objectAtIndex:2];
    // Singleton
    DataManager *dataManager = [DataManager sharedManager];
    dataManager.foodName = [NSString stringWithFormat:@"%@", _tempName];
    dataManager.foodImage = [NSString stringWithFormat:@"%@", _tempImg];
    dataManager.foodDescription = [NSString stringWithFormat:@"%@", _tempDesc];
    NSLog(@"%@ %@ %@", dataManager.foodName, dataManager.foodImage, dataManager.foodDescription);
    // Customize "Back" button of detailsView
    UIBarButtonItem *myBarButtonItem = [UIBarButtonItem new];
    myBarButtonItem.title = @"Back";
    self.navigationItem.backBarButtonItem = myBarButtonItem;
    
    [self.navigationController pushViewController:_detailsView animated:YES];
}
// load data from file plist
- (void)loadData {
    NSString *filePath = [[NSBundle mainBundle] pathForResource:@"FoodList" ofType:@"plist"];
    if(filePath != nil) {
        //_plistData = [NSDictionary dictionaryWithContentsOfFile:filePath];
        _plistData = [[NSDictionary alloc] initWithContentsOfFile:filePath];
    }
}
@end
